<?php
namespace codeneric\phmm\elementor\widget {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\Utils;
  class Portal extends \Elementor\Widget_Base {
    public function get_name() {
      return "codeneric_phmm_portal";
    }
    public function get_title() {
      return \__("Photography Management Portal", "photography-management");
    }
    public function get_icon() {
      return "fa fa-camera";
    }
    public function get_categories() {
      return array("codeneric-phmm");
    }
    protected function _register_controls() {
      $this->start_controls_section(
        "login_section",
        array(
          "label" => \__("Login form", "photography-management"),
          "tab" => \Elementor\Controls_Manager::TAB_ADVANCED
        )
      );
      $this->add_control(
        "overwrite_username_label",
        array(
          "label" => \__("Username label", "photography-management"),
          "type" => \Elementor\Controls_Manager::POPOVER_TOGGLE,
          "label_off" => \__("Use Default", "photography-management"),
          "label_on" => \__("Custom", "photography-management"),
          "return_value" => "enabled"
        )
      );
      $this->start_popover();
      $this->add_control(
        "label_username",
        array(
          "label" => \__("Username label", "photography-management"),
          "type" => \Elementor\Controls_Manager::TEXT
        )
      );
      $this->end_popover();
      $this->add_control(
        "overwrite_password_label",
        array(
          "label" => \__("Password label", "photography-management"),
          "type" => \Elementor\Controls_Manager::POPOVER_TOGGLE,
          "label_off" => \__("Use Default", "photography-management"),
          "label_on" => \__("Custom", "photography-management"),
          "return_value" => "enabled"
        )
      );
      $this->start_popover();
      $this->add_control(
        "label_password",
        array(
          "label" => \__("Password label", "photography-management"),
          "type" => \Elementor\Controls_Manager::TEXT
        )
      );
      $this->end_popover();
      $this->add_control(
        "overwrite_remember_label",
        array(
          "label" => \__("Remember label", "photography-management"),
          "type" => \Elementor\Controls_Manager::POPOVER_TOGGLE,
          "label_off" => \__("Use Default", "photography-management"),
          "label_on" => \__("Custom", "photography-management"),
          "return_value" => "enabled"
        )
      );
      $this->start_popover();
      $this->add_control(
        "label_remember",
        array(
          "label" => \__("Remember label", "photography-management"),
          "type" => \Elementor\Controls_Manager::TEXT
        )
      );
      $this->end_popover();
      $this->add_control(
        "overwrite_log_in_label",
        array(
          "label" => \__("Login label", "photography-management"),
          "type" => \Elementor\Controls_Manager::POPOVER_TOGGLE,
          "label_off" => \__("Use Default", "photography-management"),
          "label_on" => \__("Custom", "photography-management"),
          "return_value" => "enabled"
        )
      );
      $this->start_popover();
      $this->add_control(
        "label_log_in",
        array(
          "label" => \__("Login label", "photography-management"),
          "type" => \Elementor\Controls_Manager::TEXT
        )
      );
      $this->end_popover();
      $this->end_controls_section();
    }
    private function make_shortcode_attributes($settings) {
      $shortcodeAttributes = "";
      $keys = $this->get_setting_keys();
      foreach ($keys as $key) {
        $label_key = "label_".$key;
        if (\hacklib_cast_as_boolean(
              Utils::exists_and_equals(
                $settings,
                "overwrite_".$key."_label",
                "enabled"
              )
            ) &&
            \hacklib_cast_as_boolean(
              \array_key_exists("label_".$key, $settings)
            )) {
          $shortcodeAttributes .=
            "label_".$key."=\"".$settings["label_".$key]."\" ";
        }
      }
      return $shortcodeAttributes;
    }
    private function get_setting_keys() {
      return array("username", "remember", "password", "log_in");
    }
    protected function render() {
      $settings = $this->get_settings_for_display();
      $attributes = $this->make_shortcode_attributes($settings);
      $plugin = \Elementor\Plugin::instance();
      if (\hacklib_cast_as_boolean($plugin->preview->is_preview_mode()) ||
          \hacklib_cast_as_boolean($plugin->editor->is_edit_mode())) {
        $keys = $this->get_setting_keys();
        foreach ($keys as $key) {
          if (!\hacklib_cast_as_boolean(
                Utils::exists_and_equals(
                  $settings,
                  "overwrite_".$key."_label",
                  "enabled"
                )
              )) {
            $settings["label_".$key] = null;
          }
        }
        $a = \shortcode_atts(
          array(
            "remember" => null,
            "form_id" => null,
            "id_username" => null,
            "id_password" => null,
            "id_remember" => null,
            "id_submit" => null,
            "label_username" => null,
            "label_password" => null,
            "label_remember" => null,
            "label_log_in" => null,
            "value_username" => null,
            "value_remember" => null
          ),
          $settings
        );
        $options = array();
        foreach ($a as $key => $value) {
          if (!\hacklib_cast_as_boolean(\is_null($value))) {
            $options[$key] = $value;
          }
        }
        \wp_login_form($options);
        return;
      }
      echo
        ("[".
         \codeneric\phmm\base\frontend\Shortcodes::PORTAL.
         " ".
         $attributes.
         "]")
      ;
    }
  }
}
