<?php
namespace codeneric\phmm\base\admin {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\base\globals\Superglobals;
  use \codeneric\phmm\base\includes\ABTest;
  use \codeneric\phmm\base\includes\ABTestGroup;
  use \codeneric\phmm\base\includes\ABTestName;
  use \codeneric\phmm\Utils;
  use \codeneric\phmm\Configuration;
  use \codeneric\phmm\enums\AdvancedBoolSettings;
  class Installation_Wizard {
    private static $menu_slug = "cc-phmm-setup";
    private static
      $was_open_option_name = "codeneric_phmm_install_wizard_was_open";
    private static
      $group_option_name = "codeneric_phmm_install_wizard_group";
    public static function add_installation_wizard_menu_page() {
      \add_dashboard_page("", "", "manage_options", self::$menu_slug, "");
    }
    private static function setup_wizard_html() {
      \update_option(self::$was_open_option_name, true);
      $config = Configuration::get();
      $js = $config[\hacklib_id("assets")][\hacklib_id("js")][\hacklib_id(
        "admin"
      )][\hacklib_id("installation.wizard")];
      $url = \plugins_url("/", $config[\hacklib_id("manifest_path")]);
      $dashboardURL = \get_dashboard_url();
      $ajax_url = \admin_url("admin-ajax.php");
      $new_gallery_url = \add_query_arg(
        array("post_type" => $config[\hacklib_id("client_post_type")]),
        \admin_url("post-new.php")
      );
      \set_current_screen();
      \ob_start();
      \wp_admin_css("buttons", true);
      \wp_admin_css("wp-admin", true);
      $nativeStyles = \ob_get_contents();
      \ob_end_clean();
      $globals =
        "<script>\n        window.codeneric_phmm_plugins_dir = \"".
        $url.
        "\";    \n        window.codeneric_phmm_dashboard_url = \"".
        $dashboardURL.
        "\";\n        window.codeneric_phmm_new_gallery_url = \"".
        $new_gallery_url.
        "\";\n        window.ajax_url =   \"".
        $ajax_url.
        "\";   \n     </script>";
      $scripts = \array_reduce(
        $js,
        function($str, $link) {
          return $str."<script src=\"".$link."\" ></script>";
        },
        ""
      );
      $ms = self::$menu_slug;
      echo
        ("<!DOCTYPE html>\n\t\t    <html>\n                <head>\n                    <meta name='viewport' content='width=device-width' />\n                    <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />\n\n                    ".
         $nativeStyles.
         "\n                    ".
         $globals.
         "\n                </head>\n                <body class='".
         $ms.
         " wp-core-ui'>                    \n                    <div id='app' />\n\n\n                     ".
         $scripts.
         "\n                </body>\n            </html>")
      ;
    }
    public static function installation_wizard() {
      $get = Superglobals::Get();
      if (\hacklib_cast_as_boolean(
            Utils::exists_and_equals($get, "page", self::$menu_slug)
          )) {
        self::setup_wizard_html();
        exit();
      } else {
        if (\hacklib_cast_as_boolean(self::should_redirect_to_wizard())) {
          self::redirect_to_wizard();
        }
        return;
      }
    }
    private static function should_redirect_to_wizard() {
      $wizard_enabled = Utils::get_advanced_bool_setting(
        AdvancedBoolSettings::PHMM_ENABLE_INSTALLATION_WIZARD
      );
      if (!\hacklib_cast_as_boolean($wizard_enabled)) {
        return false;
      }
      $get = Superglobals::Get();
      $config = Configuration::get();
      $settings = Settings::getCurrentSettings();
      if ((!\hacklib_cast_as_boolean(
             Utils::exists_and_equals(
               $get,
               "post_type",
               $config[\hacklib_id("client_post_type")]
             )
           )) &&
          (!\hacklib_cast_as_boolean(
             Utils::exists_and_equals(
               $get,
               "post_type",
               $config[\hacklib_id("project_post_type")]
             )
           ))) {
        return false;
      }
      if (!\hacklib_cast_as_boolean(\is_admin())) {
        return false;
      }
      if (!\hacklib_cast_as_boolean(Utils::is_current_user_admin())) {
        return false;
      }
      if ($settings[\hacklib_id("portal_page_id")] !== null) {
        return false;
      }
      $wizard_already_open =
        Utils::exists_and_equals($get, "page", self::$menu_slug);
      $was_open_in_the_past = self::was_open_in_the_past();
      $is_test_group_member =
        !\hacklib_cast_as_boolean($config[\hacklib_id("premium_ext_active")]);
      return
        (!\hacklib_cast_as_boolean($wizard_already_open)) &&
        (!\hacklib_cast_as_boolean($was_open_in_the_past)) &&
        \hacklib_cast_as_boolean($is_test_group_member);
    }
    private static function redirect_to_wizard() {
      $wizard_url = self::get_setup_url();
      \update_option(self::$was_open_option_name, true);
      \wp_redirect($wizard_url);
      exit();
    }
    public static function was_open_in_the_past() {
      return (bool) \hacklib_cast_as_boolean(
        \get_option(self::$was_open_option_name, false)
      );
    }
    public static function get_setup_url() {
      $wizard_url = \add_query_arg(
        array("page" => self::$menu_slug),
        \admin_url("index.php")
      );
      $settings = Settings::getCurrentSettings();
      if (\hacklib_cast_as_boolean(
            $settings[\hacklib_id("analytics_opt_in")]
          )) {
        $wizard_url = $wizard_url."#portal";
      }
      return $wizard_url;
    }
  }
}
