<?php
namespace codeneric\phmm\legacy\validate {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\legacy\type\client_data_representation_4_0_0;
  use \codeneric\phmm\legacy\type\project_data_representation_4_0_0;
  use \codeneric\phmm\legacy\type\client_data_representation_3_6_5;
  use \codeneric\phmm\legacy\type\comment_data_representation_3_6_5;
  use \codeneric\phmm\legacy\type\project_data_representation_3_6_5;
  use \codeneric\phmm\legacy\type\plugin_settings_data_representation_3_6_5;
  use \codeneric\phmm\base\includes\Error;
  class Handler {
    private static function init($schema, $baseUrl = null) {
      if (\hacklib_cast_as_boolean(is_null($baseUrl))) {
        $baseUrl = plugin_dir_path(__FILE__);
      }
      $schemaStorage = new \JsonSchema\SchemaStorage();
      foreach (glob($baseUrl."*.json") as $filename) {
        $json = json_decode(file_get_contents($filename));
        $temp_s = basename($filename);
        $schemaStorage->addSchema("file://".$temp_s, $json);
      }
      $validatorFactory = new \JsonSchema\Constraints\Factory($schemaStorage);
      return array($schemaStorage, $validatorFactory);
    }
    public static function validate($data, $schema) {
      list($schemaStorage, $validatorFactory) = self::init($schema);
      $validator = new \JsonSchema\Validator($validatorFactory);
      $json = $schemaStorage->getSchema("file://".$schema);
      $validator->validate(
        $data,
        $json,
        \JsonSchema\Constraints\Constraint::CHECK_MODE_APPLY_DEFAULTS |
        \JsonSchema\Constraints\Constraint::CHECK_MODE_COERCE_TYPES
      );
      $validator->reset();
      $validator->validate(
        $data,
        $json,
        \JsonSchema\Constraints\Constraint::CHECK_MODE_NORMAL |
        \JsonSchema\Constraints\Constraint::CHECK_MODE_TYPE_CAST
      );
      return array($data, $validator);
    }
  }
  function client_data_representation_4_0_0($data) {
    $func = function($data) {
      list($d, $v) =
        Handler::validate($data, "client_data_representation_4_0_0.json");
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
  function project_data_representation_4_0_0($data) {
    $func = function($data) {
      list($d, $v) =
        Handler::validate($data, "project_data_representation_4_0_0.json");
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
  function client_data_representation_3_6_5($data) {
    $func = function($data) {
      list($d, $v) =
        Handler::validate($data, "client_data_representation_3_6_5.json");
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
  function project_data_representation_3_6_5($data) {
    $func = function($data) {
      list($d, $v) =
        Handler::validate($data, "project_data_representation_3_6_5.json");
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
  function comment_data_representation_3_6_5($data) {
    $func = function($data) {
      list($d, $v) =
        Handler::validate($data, "comment_data_representation_3_6_5.json");
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
  function plugin_settings_data_representation_3_6_5($data) {
    $func = function($data) {
      list($d, $v) = Handler::validate(
        $data,
        "plugin_settings_data_representation_3_6_5.json"
      );
      return /* UNSAFE_EXPR */ array($d, $v);
    };
    list($d, $v) = $func($data);
    \HH\invariant(
      $v->isValid(),
      "%s",
      new Error("Params are not valid!", $v->getErrors())
    );
    return $d;
  }
}
