<?php
namespace codeneric\phmm\base\includes {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  use \codeneric\phmm\Utils;
  use \codeneric\phmm\Configuration;
  final class ABTestGroup {
    private function __construct() {}
    private static
      $hacklib_values = array(
        "EXCLUDED" => "excluded_group",
        "REFERENCE" => "reference_group",
        "TEST" => "test_group"
      );
    use \HH\HACKLIB_ENUM_LIKE;
    const EXCLUDED = "excluded_group";
    const REFERENCE = "reference_group";
    const TEST = "test_group";
  }
  final class ABTestName {
    private function __construct() {}
    private static
      $hacklib_values = array("install_wizard" => "install_wizard");
    use \HH\HACKLIB_ENUM_LIKE;
    const install_wizard = "install_wizard";
  }
  class ABTest {
    private static $group_option_name_prefix = "codeneric_phmm_abtest";
    public static function get_group($test_name, $exclude_old_users = true) {
      $group_option_name = self::$group_option_name_prefix."_".$test_name;
      $group = \get_transient($group_option_name);
      if ($group !== false) {
        return $group;
      }
      if (\hacklib_cast_as_boolean($exclude_old_users)) {
        if (\hacklib_cast_as_boolean(self::is_old_user())) {
          \set_transient($group_option_name, ABTestGroup::EXCLUDED);
          return ABTestGroup::EXCLUDED;
        }
      }
      $group =
        (\rand(0, 1) === 0) ? ABTestGroup::TEST : ABTestGroup::REFERENCE;
      \set_transient($group_option_name, $group);
      return $group;
    }
    public static function is_old_user() {
      $config = Configuration::get();
      $install_time = (int) \get_option(
        $config[\hacklib_id("option_install_time")],
        \time()
      );
      return $install_time < (\time() - 600);
    }
  }
}
